Index: issm/trunk/src/c/analyses/BalancethicknessAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/BalancethicknessAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/BalancethicknessAnalysis.cpp	(revision 26744)
@@ -99,5 +99,5 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.surface",SurfaceEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.base",BaseEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxEnum);
@@ -118,4 +118,7 @@
 /*Finite Element Analysis*/
 void           BalancethicknessAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           BalancethicknessAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
@@ -146,5 +149,5 @@
 	int domaintype;
 	element->FindParam(&domaintype,DomainTypeEnum);
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return Ke;
 }/*}}}*/
@@ -334,5 +337,5 @@
 	int domaintype;
 	element->FindParam(&domaintype,DomainTypeEnum);
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return pe;
 }/*}}}*/
Index: issm/trunk/src/c/analyses/BalancethicknessAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/BalancethicknessAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/BalancethicknessAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/BalancethicknessSoftAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/BalancethicknessSoftAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/BalancethicknessSoftAnalysis.cpp	(revision 26744)
@@ -29,4 +29,7 @@
 	_error_("not implemented");
 }/*}}}*/
+void           BalancethicknessSoftAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* BalancethicknessSoftAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk/src/c/analyses/BalancethicknessSoftAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/BalancethicknessSoftAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/BalancethicknessSoftAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/BalancevelocityAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/BalancevelocityAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/BalancevelocityAnalysis.cpp	(revision 26744)
@@ -41,5 +41,5 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.surface",SurfaceEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.base",BaseEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxEnum);
@@ -59,4 +59,7 @@
 /*Finite Element Analysis*/
 void           BalancevelocityAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           BalancevelocityAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
@@ -231,5 +234,5 @@
 	xDelete<IssmDouble>(Ny);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return pe;
 }/*}}}*/
Index: issm/trunk/src/c/analyses/BalancevelocityAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/BalancevelocityAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/BalancevelocityAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/DamageEvolutionAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/DamageEvolutionAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/DamageEvolutionAnalysis.cpp	(revision 26744)
@@ -70,5 +70,4 @@
 		element->SetElementInput(inputs,DamageFEnum,0.);
 	}
-
 
 	/*What input do I need to run my damage evolution model?*/
@@ -121,4 +120,7 @@
 /*Finite Element Analysis*/
 void           DamageEvolutionAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           DamageEvolutionAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
@@ -806,4 +808,9 @@
 	return Me;
 }/*}}}*/
+ElementVector* DamageEvolutionAnalysis::CreateFctPVector(Element* element){/*{{{*/
+
+	return this->CreatePVector(element);
+
+}/*}}}*/
 void           DamageEvolutionAnalysis::FctKMatrix(Matrix<IssmDouble>** pKff,Matrix<IssmDouble>** pKfs,FemModel* femmodel){/*{{{*/
 
@@ -834,4 +841,24 @@
 	}
 }/*}}}*/
+void           DamageEvolutionAnalysis::FctPVector(Vector<IssmDouble>** ppf,FemModel* femmodel){/*{{{*/
+
+	/*Output*/
+	Vector<IssmDouble>* pf = NULL;
+
+	/*Initialize P vector*/
+	AllocateSystemMatricesx(NULL,NULL,NULL,&pf,femmodel);
+
+	/*Create and assemble matrix*/
+	for(Object* & object : femmodel->elements->objects){
+		Element*       element = xDynamicCast<Element*>(object);
+		ElementVector* pe      = this->CreateFctPVector(element);
+		if(pe) pe->AddToGlobal(pf);
+		delete pe;
+	}
+	pf->Assemble();
+
+	/*Assign output pointer*/
+	*ppf=pf;
+}/*}}}*/
 void           DamageEvolutionAnalysis::MassMatrix(Matrix<IssmDouble>** pMff,FemModel* femmodel){/*{{{*/
 
Index: issm/trunk/src/c/analyses/DamageEvolutionAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/DamageEvolutionAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/DamageEvolutionAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		void           CreateDamageFInput(Element* element);
 		void           CreateDamageFInputArctan(Element* element);
@@ -38,6 +39,8 @@
 		ElementMatrix* CreateFctKMatrix(Element* element);
 		ElementMatrix* CreateMassMatrix(Element* element);
+		ElementVector* CreateFctPVector(Element* element);
 		void           FctKMatrix(Matrix<IssmDouble>** pKff,Matrix<IssmDouble>** pKfs,FemModel* femmodel);
 		void           MassMatrix(Matrix<IssmDouble>** pMff,FemModel* femmodel);
+		void				FctPVector(Vector<IssmDouble>** ppf,FemModel* femmodel);
 };
 #endif
Index: issm/trunk/src/c/analyses/DepthAverageAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/DepthAverageAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/DepthAverageAnalysis.cpp	(revision 26744)
@@ -38,4 +38,7 @@
 /*Finite Element Analysis*/
 void           DepthAverageAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           DepthAverageAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
Index: issm/trunk/src/c/analyses/DepthAverageAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/DepthAverageAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/DepthAverageAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/EnthalpyAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/EnthalpyAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/EnthalpyAnalysis.cpp	(revision 26744)
@@ -136,5 +136,5 @@
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.thickness",ThicknessEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.surface",SurfaceEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.base",BaseEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
@@ -307,5 +307,5 @@
 
 /*Finite Element Analysis*/
-void           EnthalpyAnalysis::ApplyBasalConstraints(IssmDouble* serial_spc,Element* element){/*{{{*/
+void           EnthalpyAnalysis::ApplyBasalConstraints(IssmDouble* local_spc,Element* element){/*{{{*/
 
 	/* Do not check if ice in element, this may lead to inconsistencies between cpu partitions */
@@ -317,5 +317,4 @@
 	int         numindices;
 	int        *indices = NULL;
-	Node*       node = NULL;
 	IssmDouble	pressure;
 
@@ -325,5 +324,5 @@
 
 	/*Get parameters and inputs: */
-	Input* pressure_input		 = element->GetInput(PressureEnum);							 _assert_(pressure_input);
+	Input* pressure_input = element->GetInput(PressureEnum); _assert_(pressure_input);
 
 	/*Fetch indices of basal & surface nodes for this finite element*/
@@ -338,7 +337,7 @@
 
 		/*apply or release spc*/
-		node=element->GetNode(indices[i]);
+		Node* node=element->GetNode(indices[i]);
 		if(!node->IsActive()) continue;
-		if(serial_spc[node->Sid()]==1.){
+		if(local_spc[node->Lid()]==1.){
 			pressure_input->GetInputValue(&pressure, gauss);
 			node->ApplyConstraint(0,PureIceEnthalpy(element,pressure));
@@ -372,5 +371,5 @@
 
 	/* Only compute melt rates at the base of grounded ice*/
-	if(!element->IsOnBase() || element->IsFloating()) return;
+	if(!element->IsOnBase() || element->IsAllFloating()) return;
 
 	/* Intermediaries */
@@ -410,10 +409,7 @@
 	Input* pressure_input       = element->GetInput(PressureEnum);                    _assert_(pressure_input);
 	Input* geothermalflux_input = element->GetInput(BasalforcingsGeothermalfluxEnum); _assert_(geothermalflux_input);
-	Input* vx_input             = element->GetInput(VxEnum);                          _assert_(vx_input);
-	Input* vy_input             = element->GetInput(VyEnum);                          _assert_(vy_input);
-	Input* vz_input             = element->GetInput(VzEnum);                          _assert_(vz_input);
 
 	/*Build friction element, needed later: */
-	Friction* friction=new Friction(element,dim);
+	Friction* friction=new Friction(element,3);
 
 	/******** MELTING RATES  ************************************//*{{{*/
@@ -471,5 +467,5 @@
 			/*basal friction*/
 			friction->GetAlpha2(&alpha2,gauss);
-			vx_input->GetInputValue(&vx,gauss);		vy_input->GetInputValue(&vy,gauss);		vz_input->GetInputValue(&vz,gauss);
+			friction->GetBasalSlidingSpeeds(&vx, &vy, &vz, gauss);
 			basalfriction=alpha2*(vx*vx + vy*vy + vz*vz);
 			geothermalflux_input->GetInputValue(&geothermalflux,gauss);
@@ -547,4 +543,7 @@
 	PostProcessing(femmodel);
 
+}/*}}}*/
+void           EnthalpyAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
 }/*}}}*/
 ElementVector* EnthalpyAnalysis::CreateDVector(Element* element){/*{{{*/
@@ -726,5 +725,5 @@
 
 	/*Initialize Element matrix and return if necessary*/
-	if(!element->IsOnBase() || !element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || !element->IsAllFloating()) return NULL;
 
 	/*Intermediaries*/
@@ -920,5 +919,5 @@
 
 	/* implementation of the basal condition decision chart of Aschwanden 2012, Fig.5 */
-	if(!element->IsOnBase() || element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || element->IsAllFloating()) return NULL;
 
 	bool converged, isdynamicbasalspc;
@@ -945,7 +944,4 @@
 	if(dt==0. && !converged) enthalpy_enum=EnthalpyPicardEnum; // use enthalpy from last iteration
 	else enthalpy_enum=EnthalpyEnum; // use enthalpy from last time step
-	Input* vx_input             = element->GetInput(VxEnum);                          _assert_(vx_input);
-	Input* vy_input             = element->GetInput(VyEnum);                          _assert_(vy_input);
-	Input* vz_input             = element->GetInput(VzEnum);                          _assert_(vz_input);
 	Input* enthalpy_input		 = element->GetInput(enthalpy_enum);					 _assert_(enthalpy_input);
 	Input* pressure_input		 = element->GetInput(PressureEnum);							 _assert_(pressure_input);
@@ -986,7 +982,5 @@
 				geothermalflux_input->GetInputValue(&geothermalflux,gauss);
 				friction->GetAlpha2(&alpha2,gauss);
-				vx_input->GetInputValue(&vx,gauss);
-				vy_input->GetInputValue(&vy,gauss);
-				vz_input->GetInputValue(&vz,gauss);
+				friction->GetBasalSlidingSpeeds(&vx, &vy, &vz, gauss);
 				basalfriction=alpha2*(vx*vx+vy*vy+vz*vz);
 				heatflux=(basalfriction+geothermalflux)/(rho_ice);
@@ -1021,5 +1015,5 @@
 
 	/*Get basal element*/
-	if(!element->IsOnBase() || !element->IsFloating()) return NULL;
+	if(!element->IsOnBase() || !element->IsAllFloating()) return NULL;
 
 	IssmDouble  Hpmp,dt,Jdet,scalar_ocean,pressure;
@@ -1306,5 +1300,5 @@
 	/* Only update constraints at the base.
 	 * Floating ice is not affected by basal BC decision chart. */
-	if(!(element->IsOnBase()) || element->IsFloating()) return;
+	if(!(element->IsOnBase()) || element->IsAllFloating()) return;
 
 	/*Intermediary*/
@@ -1341,21 +1335,21 @@
 			case 0:
 				// cold, dry base: apply basal surface forcing
-				vec_spc->SetValue(element->nodes[i]->Sid(),0.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),0.,INS_VAL);
 				break;
 			case 1:
 				// cold, wet base: keep at pressure melting point
-				vec_spc->SetValue(element->nodes[i]->Sid(),1.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),1.,INS_VAL);
 				break;
 			case 2:
 				// temperate, thin refreezing base:
-				vec_spc->SetValue(element->nodes[i]->Sid(),1.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),1.,INS_VAL);
 				break;
 			case 3:
 				// temperate, thin melting base: set spc
-				vec_spc->SetValue(element->nodes[i]->Sid(),1.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),1.,INS_VAL);
 				break;
 			case 4:
 				// temperate, thick melting base:
-				vec_spc->SetValue(element->nodes[i]->Sid(),1.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),1.,INS_VAL);
 				break;
 			default:
@@ -1377,5 +1371,5 @@
 	/* Only update constraints at the base.
 	 * Floating ice is not affected by basal BC decision chart.*/
-	if(!(element->IsOnBase()) || element->IsFloating()) return;
+	if(!(element->IsOnBase()) || element->IsAllFloating()) return;
 
 	/*Intermediary*/
@@ -1414,21 +1408,21 @@
 			case 0:
 				// cold, dry base: apply basal surface forcing
-				vec_spc->SetValue(element->nodes[i]->Sid(),0.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),0.,INS_VAL);
 				break;
 			case 1:
 				// cold, wet base: keep at pressure melting point
-				vec_spc->SetValue(element->nodes[i]->Sid(),1.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),1.,INS_VAL);
 				break;
 			case 2:
 				// temperate, thin refreezing base: release spc
-				vec_spc->SetValue(element->nodes[i]->Sid(),0.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),0.,INS_VAL);
 				break;
 			case 3:
 				// temperate, thin melting base: set spc
-				vec_spc->SetValue(element->nodes[i]->Sid(),1.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),1.,INS_VAL);
 				break;
 			case 4:
 				// temperate, thick melting base: set grad H*n=0
-				vec_spc->SetValue(element->nodes[i]->Sid(),0.,INS_VAL);
+				vec_spc->SetValue(element->nodes[i]->Pid(),0.,INS_VAL);
 				break;
 			default:
@@ -1665,8 +1659,8 @@
 
 	/*Update basal dirichlet BCs for enthalpy: */
-	Vector<IssmDouble>* spc           = NULL;
-	IssmDouble*         serial_spc    = NULL;
-
-	spc=new Vector<IssmDouble>(femmodel->nodes->NumberOfNodes());
+	int numnodes            = femmodel->nodes->NumberOfNodes();
+   int localmasters        = femmodel->nodes->NumberOfNodesLocal();
+	Vector<IssmDouble>* spc = new Vector<IssmDouble>(localmasters,numnodes);
+
 	/*First create a vector to figure out what elements should be constrained*/
 	for(Object* & object : femmodel->elements->objects){
@@ -1675,7 +1669,10 @@
 	}
 
-	/*Assemble and serialize*/
+	/*Assemble*/
 	spc->Assemble();
-	serial_spc=spc->ToMPISerial();
+
+	/*Get local vector with both masters and slaves:*/
+	IssmDouble *local_spc = NULL;
+	femmodel->GetLocalVectorWithClonesNodes(&local_spc,spc);
 	delete spc;
 
@@ -1683,5 +1680,5 @@
 	for(Object* & object : femmodel->elements->objects){
 		Element* element=xDynamicCast<Element*>(object);
-		ApplyBasalConstraints(serial_spc,element);
+		ApplyBasalConstraints(local_spc,element);
 	}
 
@@ -1689,5 +1686,5 @@
 
 	/*Delete*/
-	xDelete<IssmDouble>(serial_spc);
+	xDelete<IssmDouble>(local_spc);
 }/*}}}*/
 void           EnthalpyAnalysis::UpdateConstraints(FemModel* femmodel){/*{{{*/
Index: issm/trunk/src/c/analyses/EnthalpyAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/EnthalpyAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/EnthalpyAnalysis.h	(revision 26744)
@@ -26,4 +26,5 @@
 		static void       ComputeBasalMeltingrate(Element* element);
 		void              Core(FemModel* femmodel);
+		void              PreCore(FemModel* femmodel);
 		ElementVector*    CreateDVector(Element* element);
 		ElementMatrix*    CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/EnumToAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/EnumToAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/EnumToAnalysis.cpp	(revision 26744)
@@ -14,4 +14,7 @@
 
 	switch(analysis_enum){
+		#ifdef _HAVE_HYDROLOGYTWS_
+		case HydrologyTwsAnalysisEnum : return new HydrologyTwsAnalysis();
+		#endif
 		#ifdef _HAVE_ADJOINTBALANCETHICKNESS2_
 		case AdjointBalancethickness2AnalysisEnum : return new AdjointBalancethickness2Analysis();
@@ -65,7 +68,4 @@
 		case GLheightadvectionAnalysisEnum : return new GLheightadvectionAnalysis();
 		#endif
-		#ifdef _HAVE_GIA_
-		case GiaAnalysisEnum : return new GiaAnalysis();
-		#endif
 		#ifdef _HAVE_HYDROLOGYDCEFFICIENT_
 		case HydrologyDCEfficientAnalysisEnum : return new HydrologyDCEfficientAnalysis();
@@ -74,15 +74,15 @@
 		case HydrologyDCInefficientAnalysisEnum : return new HydrologyDCInefficientAnalysis();
 		#endif
-		#ifdef _HAVE_HYDROLOGYSHREVE_
-		case HydrologyShreveAnalysisEnum : return new HydrologyShreveAnalysis();
-		#endif
 		#ifdef _HAVE_HYDROLOGYGLADS_
 		case HydrologyGlaDSAnalysisEnum : return new HydrologyGlaDSAnalysis();
+		#endif
+		#ifdef _HAVE_HYDROLOGYPISM_
+		case HydrologyPismAnalysisEnum : return new HydrologyPismAnalysis();
 		#endif
 		#ifdef _HAVE_HYDROLOGYSHAKTI_
 		case HydrologyShaktiAnalysisEnum : return new HydrologyShaktiAnalysis();
 		#endif
-		#ifdef _HAVE_HYDROLOGYPISM_
-		case HydrologyPismAnalysisEnum : return new HydrologyPismAnalysis();
+		#ifdef _HAVE_HYDROLOGYSHREVE_
+		case HydrologyShreveAnalysisEnum : return new HydrologyShreveAnalysis();
 		#endif
 		#ifdef _HAVE_L2PROJECTIONBASE_
@@ -104,6 +104,12 @@
 		case MeltingAnalysisEnum : return new MeltingAnalysis();
 		#endif
-		#ifdef _HAVE_SEALEVELRISE_
-		case SealevelriseAnalysisEnum : return new SealevelriseAnalysis();
+		#ifdef _HAVE_OCEANTRANSPORT_
+		case OceantransportAnalysisEnum : return new OceantransportAnalysis();
+		#endif
+		#ifdef _HAVE_SAMPLING_
+		case SamplingAnalysisEnum : return new SamplingAnalysis();
+		#endif
+		#ifdef _HAVE_SEALEVELCHANGE_
+		case SealevelchangeAnalysisEnum : return new SealevelchangeAnalysis();
 		#endif
 		#ifdef _HAVE_SMB_
Index: issm/trunk/src/c/analyses/EnumToAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/EnumToAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/EnumToAnalysis.h	(revision 26744)
@@ -17,4 +17,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/EsaAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/EsaAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/EsaAnalysis.cpp	(revision 26744)
@@ -32,5 +32,5 @@
 	/*Create inputs: */
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.esa.deltathickness",EsaDeltathicknessEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.esa.deltathickness",DeltaIceThicknessEnum);
 
 }/*}}}*/
@@ -61,5 +61,5 @@
 	/*some constant parameters: */
 	parameters->AddObject(iomodel->CopyConstantObject("md.esa.hemisphere",EsaHemisphereEnum));
-	parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.settings.rigid",SolidearthSettingsRigidEnum));
+	parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.settings.selfattraction",SolidearthSettingsSelfAttractionEnum));
 	parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.settings.horiz",SolidearthSettingsHorizEnum));
 	parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.settings.elastic",SolidearthSettingsElasticEnum));
@@ -189,4 +189,7 @@
 	_error_("not implemented");
 }/*}}}*/
+void           EsaAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
 ElementVector* EsaAnalysis::CreateDVector(Element* element){/*{{{*/
 	/*Default, return NULL*/
Index: issm/trunk/src/c/analyses/EsaAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/EsaAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/EsaAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/ExtrapolationAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/ExtrapolationAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/ExtrapolationAnalysis.cpp	(revision 26744)
@@ -71,4 +71,7 @@
 		femmodel->RequestedOutputsx(&femmodel->results,&extvar_enum,1);
 	}
+}/*}}}*/
+void           ExtrapolationAnalysis::PreCore(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
 }/*}}}*/
 ElementVector* ExtrapolationAnalysis::CreateDVector(Element* element){/*{{{*/
Index: issm/trunk/src/c/analyses/ExtrapolationAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/ExtrapolationAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/ExtrapolationAnalysis.h	(revision 26744)
@@ -10,5 +10,5 @@
 
 class ExtrapolationAnalysis: public Analysis{
-	
+
  public:
 	/*Model processing*/
@@ -22,4 +22,5 @@
 	/*Finite element Analysis*/
 	void           Core(FemModel* femmodel);
+	void           PreCore(FemModel* femmodel);
 	ElementVector* CreateDVector(Element* element);
 	ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/ExtrudeFromBaseAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/ExtrudeFromBaseAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/ExtrudeFromBaseAnalysis.cpp	(revision 26744)
@@ -38,4 +38,7 @@
 /*Finite Element Analysis*/
 void           ExtrudeFromBaseAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           ExtrudeFromBaseAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
Index: issm/trunk/src/c/analyses/ExtrudeFromBaseAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/ExtrudeFromBaseAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/ExtrudeFromBaseAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/ExtrudeFromTopAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/ExtrudeFromTopAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/ExtrudeFromTopAnalysis.cpp	(revision 26744)
@@ -38,4 +38,7 @@
 /*Finite Element Analysis*/
 void           ExtrudeFromTopAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           ExtrudeFromTopAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
Index: issm/trunk/src/c/analyses/ExtrudeFromTopAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/ExtrudeFromTopAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/ExtrudeFromTopAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 26744)
@@ -74,5 +74,5 @@
 
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.surface",SurfaceEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.groundedice_melting_rate",BasalforcingsGroundediceMeltingRateEnum,0.);
@@ -88,9 +88,15 @@
 
 	/*Get what we need for ocean-induced basal melting*/
+	bool isstochastic;
 	int basalforcing_model;
 	iomodel->FindConstant(&basalforcing_model,"md.basalforcings.model");
+	iomodel->FindConstant(&isstochastic,"md.stochasticforcing.isstochasticforcing");
 	switch(basalforcing_model){
 		case FloatingMeltRateEnum:
 			iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.floatingice_melting_rate",BasalforcingsFloatingiceMeltingRateEnum);
+			if(isstochastic){
+            iomodel->FetchDataToInput(inputs,elements,"md.stochasticforcing.default_id",StochasticForcingDefaultIdEnum);
+            iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.floatingice_melting_rate",BaselineBasalforcingsFloatingiceMeltingRateEnum);
+         }
 			break;
 		case LinearFloatingMeltRateEnum:
@@ -127,4 +133,7 @@
 /*Finite Element Analysis*/
 void           FreeSurfaceBaseAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           FreeSurfaceBaseAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
@@ -267,5 +276,5 @@
 	xDelete<IssmDouble>(D);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return Ke;
 }/*}}}*/
@@ -341,5 +350,5 @@
 	xDelete<IssmDouble>(basis);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	return pe;
 
Index: issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
Index: issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.cpp	(revision 25994)
+++ issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.cpp	(revision 26744)
@@ -77,5 +77,5 @@
 
 	iomodel->FetchDataToInput(inputs,elements,"md.geometry.surface",SurfaceEnum);
-	iomodel->FetchDataToInput(inputs,elements,"md.solidearth.initialsealevel",SealevelEnum,0);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sealevel",SealevelEnum,0);
 	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(inputs,elements,"md.initialization.vx",VxEnum);
@@ -101,4 +101,7 @@
 /*Finite Element Analysis*/
 void           FreeSurfaceTopAnalysis::Core(FemModel* femmodel){/*{{{*/
+	_error_("not implemented");
+}/*}}}*/
+void           FreeSurfaceTopAnalysis::PreCore(FemModel* femmodel){/*{{{*/
 	_error_("not implemented");
 }/*}}}*/
@@ -244,5 +247,5 @@
 	xDelete<IssmDouble>(D);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	return Ke;
 }/*}}}*/
@@ -313,5 +316,5 @@
 	xDelete<IssmDouble>(basis);
 	delete gauss;
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	return pe;
 
Index: issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.h	(revision 25994)
+++ issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.h	(revision 26744)
@@ -22,4 +22,5 @@
 		/*Finite element Analysis*/
 		void           Core(FemModel* femmodel);
+		void           PreCore(FemModel* femmodel);
 		ElementVector* CreateDVector(Element* element);
 		ElementMatrix* CreateJacobianMatrix(Element* element);
